#include "avisynth.h"

AVSValue __cdecl Create_MPEG2Source(AVSValue args, void*, IScriptEnvironment* env);
AVSValue __cdecl Create_TemporalSmoother(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_SelectRangeEvery(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_BlendFields(AVSValue args, void* user_data, IScriptEnvironment* env);

AVSValue __cdecl Create_MotionMask(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_MaskedMix(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_MaskedDeinterlace(AVSValue args, void* user_data, IScriptEnvironment* env);
AVSValue __cdecl Create_SmartDeinterlace(AVSValue args, void* user_data, IScriptEnvironment* env);

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit(IScriptEnvironment* env)
{
  env->AddFunction("MPEG2Source", "s", Create_MPEG2Source, 0);
  env->AddFunction("TemporalSmoother", "c[strength]i[radius]i", Create_TemporalSmoother, 0);
  env->AddFunction("SelectRangeEvery", "c[every]i[length]i[offset]i", Create_SelectRangeEvery, 0);
  env->AddFunction("BlendFields", "c", Create_BlendFields, 0);

  env->AddFunction("MotionMask", "c[mode]i[strength]i[denoise]b[fast]b", Create_MotionMask, 0);
  env->AddFunction("MaskedMix", "ccc", Create_MaskedMix, 0);
  env->AddFunction("MaskedDeinterlace", "cc[blend]b", Create_MaskedDeinterlace, 0);
  env->AddFunction("SmartDeinterlace", "c[mode]i[strength]i[denoise]b[blend]b[fast]b", Create_SmartDeinterlace, 0);

  return 0;
}
