// by dividee (dividee@caramail.com)

#include "avisynth.h"
#include "global.h"

class SelectRangeEvery : public GenericVideoFilter {
	int every, length;
public:
	SelectRangeEvery(PClip _child, int _every, int _length, int _offset, IScriptEnvironment* env)
		: GenericVideoFilter(_child)
	{
		AVSValue trimargs[3] = { _child, _offset, 0};
		PClip c = env->Invoke("Trim",AVSValue(trimargs,3)).AsClip();
		child = c;
		vi = c->GetVideoInfo();

		every = min(max(_every,0),vi.num_frames);
		length = min(max(_length,0),every);

		int n = vi.num_frames;
		vi.num_frames = (n/every)*length+(n%every<length?n%every:length);
	}
	
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) {
		return child->GetFrame((n/length)*every+(n%length), env); }

	bool __stdcall GetParity(int n)	{
		return child->GetParity((n/length)*every+(n%length)); }

};

AVSValue __cdecl Create_SelectRangeEvery(AVSValue args, void* user_data, IScriptEnvironment* env) {
    return new SelectRangeEvery(args[0].AsClip(), args[1].AsInt(1500), args[2].AsInt(50), args[3].AsInt(0), env);
}
